
# Configurations would be
# DMSystem - src/DMSystem - Debug
# DMSystem - src/DMSystem - Release
# MD - src/MD/MDFiles - Debug
# MD - src/MD/MDFiles - Release
# MD - src/MD/Console - Debug
# MD - src/MD/Console - Release

class Configuration:
	"""This class is responsible for compiling a configuration of source code."""

	def __init__(self, target = "Debug"):
		self.target = target
		self.outfile = "make"+self.target+".txt"
		# Maybe the outfile should be a cookie from the MakeSystem.

	def SetProject(self, project):
		self.project = project
	
	def SetSystem(self, system):
		self.system = system

	def Construct(self):
		directory = self.project.directory
		self.system.Execute(directory,self.project.name,self.target,self.outfile)

	def __getstate__(self):
		odict = self.__dict__
		del odict['system']
		del odict['project']
		return odict

	def __setstate__(self, ndict):
		self.__dict__ = ndict


