import os

class UnixExecutable:
	"""This version makes the command for tcsh."""
	def __init__(self,directory=".",command=None,**extras):
		self.dir = directory
		self.file = command

	def Execute(self,out=None,err=None,debug=None):
		self.out = out
		self.err = err
		if debug: print 'UnixExecutable:Execute',self.dir,':',self.file,':',out,err
		curDir = os.getcwd()
		os.chdir( self.dir )
		if out and err:
			line = "(%(file)s > %(out)s) >& %(err)s" % self.__dict__
		elif out:
			line = "%(file)s >& %(out)s" % self.__dict__
		else:
			line = "%(file)s" % self.__dict

		try:
			if debug: print 'UnixExecutable:Execute',line
			res = os.system(line)
			if debug: print 'UnixExecutable:Execute system() returned',res
		finally:
			os.chdir( curDir )

