import os

class WinExecutable:
	def __init__(self,directory=".",command=None,**extras):
		self.dir = directory
		self.file = command

	def Execute(self,out=None,err=None,debug=None):
		self.out = out
		self.err = err
		curDir = os.getcwd()
		if out and err:
			line = "%(file)s > %(out)s 2> %(err)s" % self.__dict__
		elif out:
			line = "%(file)s > %(out)s 2>&1" % self.__dict__
		else:
			line = "%(file)s" % self.__dict
		if debug: print "WinExecutable:Execute",line
		try:
			if debug: print "WinExecutable:Execute",curDir,self.dir
			os.chdir( self.dir )
			os.system(line)
		finally:
			os.chdir( curDir )

class UnixExecutable:
	"""This version makes the command for tcsh."""
	def __init__(self,directory=".",command=None):
		self.dir = directory
		self.file = file

	def Execute(self,out=None,err=None,debug=None):
		self.out = out
		self.err = err
		curDir = os.getcwd()
		os.chdir( self.dir )
		if out and err:
			line = "(%(file)s > %(out)s) >& %(err)s" % self.__dict__
		elif out:
			line = "%(file)s >& %(out)s" % self.__dict__
		else:
			line = "%(file)s" % self.__dict

		try:
			os.system(line)
		finally:
			os.chdir( curDir )

