# DMSystem/__init__.py  --  interface to the DMSystem stuff


# import the swigged module into this namespace

from DMSystem_DMSystem import *

# Replace the DoubleMatrix with an extended one
_OriginalDoubleMatrix = DoubleMatrix
del DoubleMatrix
class DoubleMatrix(_OriginalDoubleMatrix):
    """The 3*N DMMatrix of Floats."""

    def __init__(self, *args, **kargs):
        args = tuple([self] + list(args))
        apply(_OriginalDoubleMatrix.__init__, args, kargs)

    def Attach(self, branch):
        if branch.thisown != 1:
            raise ValueError, "Cannot attach an an object that is not owned by Python."
        # Do the attach in the C++ code
        retval = _OriginalDoubleMatrix.Attach(self, branch)
        # Now C++ owns the attached object
        branch.thisown = 0
        return retval
