import sys
sys.path.append('../../src/MD/SWIGBuild/i686/obj3D')
sys.path.append('../../src/QuasiContinuum/PythonScripts')

from Numeric import *
import MD3D
from plot import *
from Delaunay import *
from Thompson import Thompson_110

potential = MD3D.EMTPotential("Cu")
d = potential.GetLengthScale()
a = d * sqrt(2)
rc = d * (sqrt(5) + sqrt(4)) / 2
rc1 = d * (sqrt(2) + sqrt(1)) / 2
(A, B, C, D, alpha, beta, gamma, delta) = Thompson_110(a)
lattice = MD3D.GeneralLattice()
lattice.SetLatticeVectors(array([B - A, C - A, D - A]))
N = 2
dx = a / 2
dy = d / 2
dz = dy
Lx = (3 * 2 * N + 0) * dx
Ly = (4 * 2 * N + 0) * dy
Lz = (4 * 2 * N + 1) * dz
Lz = (5 * 2 * N) * dz
rect = MD3D.RectangularClusterInitializer([Lx, Ly, Lz / 2], lattice)
rect.SetCenter([0, 0, Lz / 4])
atoms1 = MD3D.PrimitiveListOfAtoms()
rect.Create(atoms1)
rect.SetCenter([0, 0, -Lz / 4])
atoms2 = MD3D.PrimitiveListOfAtoms()
rect.Create(atoms2)

bc = MD3D.SmartPeriodicBoundaryConditions([0, 0, 1])
bc.SetLength([Lx, Ly, Lz])
atoms1.SetBoundaryConditions(bc)
atoms = MD3D.PrimitiveListOfAtoms()
atoms.Attach(atoms1); atoms1.thisown = 0 
atoms.Attach(atoms2); atoms2.thisown = 0 
nAtomic = atoms.GetNumber()
atoms2.SetBoundaryConditions(bc)
atoms.SetBoundaryConditions(bc)
nl1=MD3D.CellNeighborList(rc, 0.05 * rc)
atoms1.SetNeighborLocator(nl1)
nl2=MD3D.CellNeighborList(rc, 0.05 * rc)
atoms2.SetNeighborLocator(nl2)
nl=MD3D.CompositeNeighborList(rc, atoms)
atoms.SetNeighborLocator(nl)

#nl = MD3D.CellNeighborList(rc, 0.05 * rc)
#atoms.SetNeighborLocator(nl)
e0 = potential.CalculateEnergy(atoms) 
print "E0: ", e0 / Lz

stop


def relax(atoms, potential, tolerance = 1e-5):
    e0 = potential.CalculateEnergy(atoms)
    mover = MD3D.QuickMinAtomsMover(potential, 
				    0.04, tolerance)
    mover.SetMaxSteps(5)
    mover.Move(atoms)
    mover.SetDt(0.15)
    mover.SetMaxSteps(100)
    while mover.GetFinalTFS() > tolerance:
	mover.Move(atoms)
	e = potential.CalculateEnergy(atoms)
	print mover.GetFinalTFS(), e, e - e0
    return potential.CalculateEnergy(atoms)

#relax(atoms, potential)

Rs = atoms.GetCartesianPositions()[:]
for (n, R) in online:
    dR = Rs[n] - R
    print R[0], dR[0], dR[1], dR[2]

