from Structures.AtomsInArrays import *
from Analysis.cna import _cna
from Analysis.SelectAtoms import *
from Numeric import *

def plot(atoms):
    return ListOfCartesianAtoms(positions = 
				atoms.GetCartesianPositions()[:]).GetPlot()

def plots(atoms, surface):
    loa = ListOfCartesianAtoms(positions = 
			       atoms.GetCartesianPositions()[:])
    types = zeros(atoms.GetNumber())
    for s in surface:
	types[s] = 1
    loa.SetClasses(types)
    p = loa.GetPlot()
    colors={0: "red", 1 : "yellow"}
    p.ColorByClasses(colors)
    return p

def plotz(atoms, z):
    pos = atoms.GetCartesianPositions()[:]
    loa = ListOfCartesianAtoms(positions = pos)
    ok = zeros(atoms.GetNumber())
    n = 0
    for r in pos:
	if(r[2] > z):
	    ok[n] = 1
	n = n + 1
    loa = SelectAtoms(loa, ok)
    p = loa.GetPlot()
    colors={1: "red", 0 : "yellow"}
    p.ColorByClasses(colors)
    return p

def plotzs(atoms, z,su):
    pos = atoms.GetCartesianPositions()[:]
    loa = ListOfCartesianAtoms(positions = pos)
    ok = zeros(atoms.GetNumber())
    n = 0
    for r in pos:
	if(r[2] > z):
	    ok[n] = 1
	n = n + 1
    loa = SelectAtoms(loa, ok)
    types = zeros(len(loa))
    for s in su:
	types[s] = 1
    loa.SetClasses(types)
    p = loa.GetPlot()
    colors={1: "red", 0 : "yellow"}
    p.ColorByClasses(colors)
    return p

def plotm2(atoms,l):
    loa = ListOfCartesianAtoms(positions = 
			       atoms.GetCartesianPositions()[:])
    types = ones(atoms.GetNumber())
    for i in l:
	types[i] = 0
    loa.SetClasses(types)
    p = loa.GetPlot()
    colors={0: "blue", 1 : "red", 2 : "yellow", 3 : "green"}
    p.ColorByClasses(colors)
    return p

def cnaplot(atoms, rc=5.5, coord=11, z = -1.0):
    pos = atoms.GetCartesianPositions()[:]
    x0 = min(pos.flat) - 1.0
    dx = max(pos.flat) + 1.0 - x0
    loa = ListOfScaledAtoms(array([[dx, 0.0, 0.0],
				   [0.0, dx, 0.0],
				   [0.0, 0.0, dx]]),
			    positions = (pos - x0) / dx)
#	loa.SetPeriodicBoundaries([
    (classes, coordinations) = _cna(loa, rc, 32)
    loa.SetClasses(classes)
    loa = SelectAtoms(loa, logical_and(not_equal(classes, 1),
				       greater(coordinations, coord)))
    p = loa.GetPlot()
    colors={1 : "blue", 2 : "red", 3 : "yellow"}
    p.ColorByClasses(colors)
    return p

def cnaplot2(atoms, rc=5.5, z=-100000):
    pos = atoms.GetCartesianPositions()[:]
    x0 = min(pos.flat) - 1.0
    dx = max(pos.flat) + 1.0 - x0
    loa = ListOfScaledAtoms(array([[dx, 0.0, 0.0],
				   [0.0, dx, 0.0],
				   [0.0, 0.0, dx]]),
			    positions = (pos - x0) / dx)
    (classes, coordinations) = _cna(loa, rc, 32)
    loa.SetClasses(classes)
    ok = zeros(len(pos))
    n = 0
    for r in pos:
	if(r[2] > z):
	    ok[n] = 1
	n = n + 1
    loa = SelectAtoms(loa, ok)
    p = loa.GetPlot()
    colors={1 : "blue", 2 : "red", 3 : "yellow"}
    p.ColorByClasses(colors)
    return p

