import CAMPpath
import MD
import sys
import time
from MD.InitializerFromCmFile import InitializerFromCmFile
from MD.MakeParallelListOfAtoms import MakeParallelListOfAtoms

def PrintListOfAtoms(loa, offset=""):
    print offset, loa
    print offset, "this =", loa.this
    print offset, "thisown =", loa.thisown
    try:
        issimple = loa.IsSimple()
    except AttributeError:
        issimple = (loa.GetNumberOfChildren() == 0)
    print offset, "Is simple:", issimple
    print offset, "Shape:", loa.GetShape()
    print offset, "Length =", len(loa)
    if not issimple:
        try:
            n = loa.GetNumberOfTypes()
        except AttributeError:
            n = loa.GetNumberOfChildren()
        for i in xrange(n):
            try:
                PrintListOfAtoms(loa.GetSubList(i), offset+"    ")
            except AttributeError:
                PrintListOfAtoms(loa.SubArray(i), offset+"    ")

init = InitializerFromCmFile("sim037B-prep.cm", verbose=1)
atoms = MD.PrimitiveListOfAtoms()
init.Create(atoms)
sys.stderr.write("\n")

# atoms = MakeParallelListOfAtoms(atoms)
PrintListOfAtoms(atoms)
PrintListOfAtoms(atoms.GetCartesianPositionsDM())

sys.exit(0)

emt = MD.EMTPotential("Cu")
nblist = MD.CellNeighborList(emt.GetCutoffDistance(), 0.135*emt.GetCutoffDistance())
# nblist = MD.NeighborList(emt.GetCutoffDistance(), 1.135*emt.GetCutoffDistance())

sys.stderr.write("*** atoms.SetNeighborLocator(nblist)\n")
atoms.SetNeighborLocator(nblist)

energy = emt.CalculateEnergy(atoms)/len(atoms)
ekin = atoms.GetKineticEnergy()/len(atoms)
print "Energy per atom:", energy, '+', ekin ,"=", energy+ekin
print "Atoms:", len(atoms)

print "Running ten verlet timesteps"
t1 = time.clock()
mover = MD.VerletAtomsMover(emt, 0.928, 5)
mover.Move(atoms)
print "Time elapsed:", time.clock() - t1

energy = emt.CalculateEnergy(atoms)/len(atoms)
ekin = atoms.GetKineticEnergy()/len(atoms)
print "Energy per atom:", energy, '+', ekin ,"=", energy+ekin
print "Atoms:", len(atoms)

sys.stderr.write("Done  (Entering ~)\n")

del atoms

sys.stderr.write("Done 2 (Entering ~)\n")
