// ASCIIWriter.h: interface for the ASCIIWriter class.
//
//////////////////////////////////////////////////////////////////////

#ifndef ASCIIWRITER_H
#define ASCIIWRITER_H


#include "DMFirstHeader.h"
#include <string>
#include <fstream>
#include "DigitalMaterial.h"
#include "DMWriter.h"

class ASCIIWriter: public DMWriter
{
public:
	ASCIIWriter(const std::string &filename = "data.txt");
	virtual ~ASCIIWriter();
	void Open();
	void Close();
	void Put(const Serializable *serializable, const std::string &name="root");
	void PutBool( bool b, const std::string& name );
	void PutInt(int n, const std::string &name);
	void PutDouble(double x, const std::string &name);
	void PutString(const std::string &str, const std::string &name);
	void PutIntArray(const int *data, const std::vector<int> &dims, const std::string &name);
	void PutDoubleArray(const double *data, const std::vector<int> &dims, const std::string &name);
private:
	void Begin(const std::string &type, const std::string &name="");
	void End();
	std::string offset;
	std::ofstream out;
};

#endif //ASCIIWRITER
