#ifndef _ATTRIBUTE_ERROR_H_
#define _ATTRIBUTE_ERROR_H_

#include "DMFirstHeader.h"
#include <string>
#include "DigitalMaterial.h"
#include "DMException.h"

//! Error when a class does not support a method.
/*! We have some fat interfaces in base classes which do no more than throw
  this exception if the concrete subclass does not support the method.
  If you get this error, you can assume that the class purposefully does
  not support this method.

  Caught in Python as an AttributeError.
*/
class AttributeError : public DMException
{
	std::string sFunction, sFile, sNCMessage;
public:
	//! Constructor.
	/*! Maybe this constructor should allow you to give a reason why you
	  don't support the method.
	*/
	AttributeError( const std::string& sFunction, const std::string& sFile );
	//! virtual destructor
	virtual ~AttributeError();
};

#endif //_ATTRIBUTE_ERROR_H_
