#ifndef _INDEX_ERROR_H_
#define _INDEX_ERROR_H_

#include "DMFirstHeader.h"
#include <string>
#include "DigitalMaterial.h"
#include "DMException.h"

//! Error when an array access is out of bounds.
/*! This will be caught in Python as, you guessed it, an IndexError.
 */
class IndexError : public DMException
{
	std::string sFunction, sFile, sNCMessage;
public:
	//! Constructor.
	IndexError( const std::string& sFunction, const std::string& sFile, const std::string&
				sNCMessage );
	//! Destructor.
	virtual ~IndexError();
};

#endif //_INDEX_ERROR_H_
