#ifndef _NETCDFERROR_H_
#define _NETCDFERROR_H_

#include "DMFirstHeader.h"
#include <string>
#include "DigitalMaterial.h"
#include "DMException.h"

//! Errors in NetCDF reading or writing.
/*! Caught in Python as an IOError. */
class NetCDFError : public DMException
{
	std::string sFunction, sFile, sNCMessage;
public:
	//! Constructor.
	NetCDFError( const std::string& sFunction, const std::string& sFile, const std::string& sNCMessage );
	//! Destructor.
	virtual ~NetCDFError();
};

#endif //_NETCDFERROR_H_
