#ifndef _DYN_SER_H_
#define _DYN_SER_H_

#include <vector>
#include <string>
#include "DigitalMaterial.h"
#include "Rand.h"
#include "Serializable.h"

class DMWriter;
class DMReader;

class DynSer : public Serializable
{

	bool bData;
	int iData;
	double dData;
	std::string sData;
	int* piData;
	std::vector<int> intShape;
	double* pdData;
	std::vector<int> doubleShape;
public:
	DynSer( int seed = 1 );
	virtual ~DynSer();
	bool IsEqual( const DynSer& toCompare );
	
	/*! Serializable interface */
	//@{
	virtual void Save( DMWriter *writer ) const;
	virtual void Load( DMReader *reader );
	virtual const std::string GetType() const { return sType; }
	//@}
	static const std::string sType;
protected:
	Rand rand;
private:
	void DeleteArrays();
};

class DynSerB : public DynSer
{
public:
	virtual const std::string GetType() const { return sType; }
	static const std::string sType;
};

class DynSerA : public DynSer
{
	DynSerA* pDynA;
	DynSerB dynB;
public:
	DynSerA( int seed = 1 );
	bool IsEqual( const DynSerA& toCompare );
	virtual ~DynSerA();
	virtual void Save( DMWriter *writer ) const;
	virtual void Load( DMReader *reader );
	virtual const std::string GetType() const { return sType; }
	static const std::string sType;
};


#endif // _DYN_SER_H_
