#ifndef _TrivialProcessFactory_H_
#define _TrivialProcessFactory_H_

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

#include "ProcessFactory.h"

//! A concrete ProcessFactory for Windows.
/**
 * This is a concrete implementation of the abstract ProcessFactory.
 * In order to use ProcessFactory::Instance() in a program, you must
 * first instantiate a TrivialProcessFactory with the call
 * TrivialProcessFactory::Create().
 *
 * Note: Imp as in ThreadImp or RWLockImp mean implementation
 *
 * \author Drew Dolgert
 * \date 28 July 2000
 * \bug There is an easier way to instantiate the ProcessFactory.
 * \ingroup dmsystem
 */
class TrivialProcessFactory : public ProcessFactory {
public:
	static void Create() {
		ProcessFactory::_instance = new TrivialProcessFactory();
	}
	virtual ThreadImp* GetThread();
	virtual RWLockImp* GetRWLock();
protected:
	TrivialProcessFactory() {}
};

#endif // _TrivialProcessFactory_H_
