/* UnixProcessFactory.h - Drew Dolgert 21 March 2000
 * This is a concrete implementation of the abstract ProcessFactory.
 */
#ifndef _UnixProcessFactory_H_
#define _UnixProcessFactory_H_

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif //SWIG

#include "ProcessFactory.h"

// A Singleton, but it doesn't make itself because a subclass has to.
class UnixProcessFactory : public ProcessFactory {
public:
	static void Create() {
		ProcessFactory::_instance = new UnixProcessFactory();
	}
	virtual ThreadImp* GetThread();
	virtual RWLockImp* GetRWLock();
	virtual EggTimer*  GetEggTimer();
protected:
	UnixProcessFactory() {}
};

#endif // _UnixProcessFactory_H_
