#ifndef _WIN_EGG_TIMER_H_
#define _WIN_EGG_TIMER_H_

#include "DMFirstHeader.h"
#include <windows.h>
#include "DigitalMaterial.h"
#include "EggTimer.h"

//! Will set a flag after given number of seconds.
/*! When this goes out of scope, the timer will
	no longer set the flag.
	*/
class WinEggTimer : public EggTimer
{
	mutable LONG lDone;	//!< This is the flag the thread sets when it finishes.
	HANDLE hTimerQueue;
	HANDLE hTimer;
public:
	//! Constructor.
	WinEggTimer( );
	//! Destructor.
	~WinEggTimer( );
	void SetDueTime( int secondsToExpire );
	//! Is it done yet?
	bool DoneYet() const;
private:
	void CreateTimerQueue();
	// EggThread is a friend so it can share the EggStruct.
	friend VOID CALLBACK WinEggCallBack( PVOID pvParam, BOOLEAN TimerOrWaitFired );
};


#endif //_WIN_EGG_TIMER_H_