// WinProcessFactory.cpp
// These things would fit in the header file, but they would
// clutter the namespace.

#include "DigitalMaterial.h"
#include "WinProcessFactory.h"
#include "WinThread.h"
#include "WinRWLock.h"

#ifdef WIN2K
#include "WinEggTimer.h"
#endif

#include "DMLastHeader.h"

ThreadImp* WinProcessFactory::GetThread()
{
	return new WinThread();
}

RWLockImp* WinProcessFactory::GetRWLock()
{
	return new WinRWLock();
}

EggTimer* WinProcessFactory::GetEggTimer()
{
#ifdef WIN2K
	return new WinEggTimer();
#else
	return 0;
#endif
}
