#ifndef _WINRWLOCK_H_
#define _WINRWLOCK_H_

#include "DMFirstHeader.h"
#include <windows.h>
#include <process.h>
#include "DigitalMaterial.h"
#include "RWLockImp.h"

//! Read-write lock for Windows.
/**
 * This is the Windows implementation of read-write locks.
 * See RWLock for details on use.
 * \author Drew Dolgert
 * \date March 2000
 * \ingroup dmsystem
 */
class WinRWLock : public RWLockImp
{
	long iCounter; //! Number of threads reading.
	HANDLE hReaderEvent; //! Event readers wait on to enter.
	HANDLE hMutexEvent; //! Keeps readers and writers from mixing.
	HANDLE hWriterMutex; //! Keeps writers and writers from mixing.
public:
	virtual bool InitializeLock();
	virtual void CleanupLock();
	virtual void ReadLock();
	virtual void WriteLock();
	virtual void ReadRelease();
	virtual void WriteRelease();
};

#endif // _WINRWLOCK_H_