#ifndef _CMD_STREAM_READER_H_
#define _CMD_STREAM_READER_H_

#include "DMFirstHeader.h"
#include <iostream>
#include <vector>
#include "DiscreteAvalanche.h"
#include "CmdParser.h"

class CmdStreamReader
{
public:
	typedef std::vector<CmdParser*> ParserVector;
private:
	ParserVector cmdParsers;
public:
	CmdStreamReader();
	virtual ~CmdStreamReader();
	bool ReadCmdStream( std::istream& cmdStream );
	CmdParser* ParserWhichMatches( const std::string& inputToken );
	const ParserVector& GetCmdParsers() const;
protected:
	void AddParser( CmdParser* pParser );
	void DestroyCmdParsers( );
};

#endif // _CMD_STREAM_READER_H_
