#include "DiscreteAvalanche.h"
#include "HysteresisCmdStreamReader.h"
#include "HysteresisCmdParsers.h"
#include "DMLastHeader.h"

HysteresisCmdStreamReader::HysteresisCmdStreamReader
	(
	HysteresisSimulation* pSim
	)
{
	AddParser( new QuitCmdParser( ) );
	AddParser( new DimCmdParser( pSim ) );
	AddParser( new DisorderCmdParser( pSim ) );
	AddParser( new SeedCmdParser( pSim ) );
	AddParser( new RunCmdParser( pSim ) );
	AddParser( new LengthCmdParser( pSim ) );
	AddParser( new ColoringParser( pSim ) );
	AddParser( new CorrelationParser( pSim ) );
	AddParser( new MagnetizationParser( pSim ) );
	AddParser( new SizeDistributionParser( pSim ) );
	AddParser( new TimeSeriesParser( pSim ) );
	AddParser( new HelpCmdParser( this ) );
	AddParser( new SetupCmdParser( pSim ) );
	AddParser( new AvgCorrelationParser( pSim ) );
	AddParser( new AvgSizeDistributionParser( pSim ) );
	AddParser( new EndTimeCmdParser( pSim ) );
	AddParser( new TraceCmdParser( pSim ) );
	AddParser( new CheckpointCmdParser( pSim ) );
	AddParser( new RestartCmdParser( pSim ) );
	AddParser( new OnSpanningParser( pSim ) );
}

HysteresisCmdStreamReader::~HysteresisCmdStreamReader()
{
}