#ifndef _AVALANCHESTART_H_
#define _AVALANCHESTART_H_

#include "DMFirstHeader.h"
#include "DiscreteAvalanche.h"
#include "SpinIndex.h"
#include "AvalancheAlgorithm.h"

class FixedFieldAvalanche;

//! Responsible for finding the start of the next avalanche.
/** 
  * This AvalancheStart uses the Sorted-List algorithm to decide at what
  * field the the next spin wants to flip and which spin that is.
  * \author ajd27
  * \date 15 August 2000
  */
class AvalancheStart
{
public:
	//! You must call Initialize after setting the algorithm.
	virtual void Initialize() PUREVIRTUAL;
	//! Ask whether everything is ready to rumble.
	virtual void Verify() const PUREVIRTUAL; // throw (FailedVerify);
	//! Finds the start of the next avalanche.
	virtual AvalancheAlgorithm::Status
		FindNextStart( double* H, SpinIndex *iFirstSpin ) PUREVIRTUAL;
};

#endif // _AVALANCHESTART_H_