#ifndef _SLOWPOINTER_
#define _SLOWPOINTER_

#include "DigitalMaterial.h"

//! This wraps a pointer so that it only increments every nth time you do ++.
/*! This can make an algorithm loop a little prettier at some time expense.
	\author ajd27
	*/
class SlowPointer
{
private:
	int *ptr;
	int count;
	int mod;
public:
	//! Constructor.
	SlowPointer(int *ptr, int mod=1) : ptr(ptr), mod(mod) { count = 0; }
	
	//! Postfix ncrement.
	SlowPointer& operator++() {
		count++;
		if (count==mod) {
			ptr++;
			count=0;
		}
		return *this;
	}
	//! Increment a certain number.
	SlowPointer operator++(int) {
		count++;
		if (count==mod) {
			ptr++;
			count=0;
		}
		return *this;
	}
	
	//! Return the value.
	int operator*() { return *ptr; }
};


#endif //_SLOWPOINTER_