#ifndef _WHOLEGRIDDD_
#define _WHOLEGRIDDD_

#include "DMFirstHeader.h"
#include "ddraw.h" // This is a system header.
#include "DigitalMaterial.h"
#include "WholeGridDisplay.h"
#include "WholeGridBase.h"

class WholeGridSource;

class WholeGridDD : public WholeGridDisplay
{
public:
	WholeGridDD();
	~WholeGridDD();
	int Initialize(HWND hwnd);
	int SetGridDimensions(int iX, int iY, int iMaxVal);
	int SetDisplayRect(RECT &dispRect );
	int GetPreferredSize(RECT& bounds, RECT& preferred);
	int SetData(WholeGridSource *data);
	int DrawToDC(HDC hDC, RECT& rect);
	HGLOBAL CreatePackedDIB(RECT& bounds);
	void Show();
private:
	WholeGridBase* gridhelp;
	HWND hwnd;  // handle to the window we use
//	HDC bufferDC; // device context for back buffer.
	LPDIRECTDRAW7 lpDD7; // our directdraw object
	DDSURFACEDESC2 ddsd, ddsd2; // the surface description for the primary surface.
	LPDIRECTDRAWSURFACE7 lpDDSPrimary, lpDDSBuffer;
	bool bDDInitialized;
	bool bOffscreenBuffer;
	bool InitializeDD();
	int CreateWindowedDD();
	int CreatePrimarySurface();
	int CreateOffscreenSurface(int cWidth, int cHeight);
	int CheckPixelFormat();
	int CreateClipper();
	void GetCurrentRect();
	bool RestoreAll();
	void ReleaseAllObjects();
	void DrawToSurface(LPDIRECTDRAWSURFACE7 lpDDS,
					DDSURFACEDESC2 ddsd, RECT& displayRect);
	void DrawToBuffer(LPVOID lpSurface, long lPitch, POINT& upperLeft);
	void DrawToBuffer16(LPVOID lpSurface, long lPitch, POINT& upperLeft);
	void DrawToBufferN(LPVOID lpSurface, long lPitch, POINT& upperLeft);
	void InitializePalette();
	DWORD BitsToMin(DWORD bitMask);

	int xDim, yDim;  // integer dimensions of 2D Grid.
	RECT displayRect;  // rectangle defining our display
	RECT bufferRect;
	COLORREF * colors; // index to default color table
	int iMaxVal;
	int cWidth;
	int cHeight;
	int iDecimate;
	int *storage;
	DWORD *palette;
	DWORD dwRGBBitCount, dwRBitMask, dwGBitMask, dwBBitMask;
//	void SetDecimation();
};

#endif // _WHOLEGRIDDD_
