#ifndef _WHOLEGRIDGDI_
#define _WHOLEGRIDGDI_

#include "DigitalMaterial.h"
#include "WholeGridDisplay.h"

class GridSource;
class WholeGridBase;

//! Displays a 2D grid of whole numbers using GDI calls.
/**
 * \author Drew Dolgert
 * \date 1 April 2000
 */
class WholeGridGDI : public WholeGridDisplay
{
public:
	//! Constructor.
	WholeGridGDI();
	//! Destructor.
	~WholeGridGDI();
	int Initialize(HWND hwnd);
	int SetGridDimensions(int iX, int iY, int iMaxVal);
	int GetPreferredSize(RECT& bounds, RECT& preferred);
	int SetDisplayRect(RECT &dispRect );
	int SetData(WholeGridSource *data);
	int DrawToDC(HDC hDC, RECT& rect);
	HGLOBAL CreatePackedDIB(RECT& bounds);
	void Show();
private:
	WholeGridBase *gridhelp;
	HWND hwnd;
	HGDIOBJ hOldBitmap;
	HBITMAP hBitmap;
	int xDim, yDim;  // integer dimensions of 2D Grid.
	RECT displayRect;  // rectangle defining our display
	int *storage;
	int cWidth;
	int cHeight;
	int iDecimate;
	int iMaxVal;
	bool bBitmapCurrent;
	void DrawToBitmap();
	HBITMAP CreateMemoryBitmap(HWND hwnd, int cWidth, int cHeight);
	HDC MemoryDCWithBitmap(HBITMAP hBitmap);
};

#endif // _WHOLEGRIDGDI_
