%{
#include "HysteresisSimulation.h"
%}

class HysteresisSimulation : public Serializable {
public:
	//! Constructor.
	HysteresisSimulation();
	//! Destructor.
	~HysteresisSimulation();

	//! Set the length of a side of the lattice.
	void SetLength( int iLength );
	
	//! Set the random seed
	void SetSeed( int iSeed );

	//! Set the amount of disorder
	void SetDisorder( double dDisorder );

	//! How long from now do we need to be done?
	void SetEndTime( long lNumberOfMinutes );

	//! Give us a timer to trace and/or checkpoint.
	void SetBatchTimer( BatchTimer* batchTimer );

	//! Initialize the simulation.
	void Initialize();

	//! Check that everything is hooked up.
	bool Verify();

	//! Tell it to run. Returns whether to quit.
	void Run();

	//! Show results
	void SaveResults() const;
	virtual void Save( DMWriter *writer ) const;
	virtual void Load( DMReader *reader );
	virtual const std::string& GetType() const;
};