
/* @(#)fdlibm.h 1.5 95/01/18 */
/*
 * ====================================================
 * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
 *
 * Developed at SunSoft, a Sun Microsystems, Inc. business.
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice 
 * is preserved.
 * ====================================================
 */

/*
 * This file has been modified to provide only the support needed for erf, erfc, and __ieee754_exp
 * (which is needed by erf and erfc) so that they will work under Microsoft Visual C++ 5.0 or gnu g++.
 */

#ifdef __cplusplus
extern "C" {
#endif
#ifdef MAXFLOAT
#undef MAXFLOAT
#endif
#ifdef HUGE
#undef HUGE
#endif

#if defined(i386) || defined(i486) || defined(intel) || defined(x86) || defined(i86pc) || defined(_WIN32)
#ifndef __LITTLE_ENDIAN
#define __LITTLE_ENDIAN
#endif
#endif


#ifdef __LITTLE_ENDIAN
#define __HI(x) *(1+(int*)&x)
#define __LO(x) *(int*)&x
#define __HIp(x) *(1+(int*)x)
#define __LOp(x) *(int*)x
#else
#define __HI(x) *(int*)&x
#define __LO(x) *(1+(int*)&x)
#define __HIp(x) *(int*)x
#define __LOp(x) *(1+(int*)x)
#endif

/*
 * ANSI/POSIX
 */

extern int signgam;

#define	MAXFLOAT	((float)3.40282346638528860e+38)

enum fdversion {fdlibm_ieee = -1, fdlibm_svid, fdlibm_xopen, fdlibm_posix};

#define _LIB_VERSION_TYPE enum fdversion
#define _LIB_VERSION _fdlib_version  

/* if global variable _LIB_VERSION is not desirable, one may 
 * change the following to be a constant by: 
 *	#define _LIB_VERSION_TYPE const enum version
 * In that case, after one initializes the value _LIB_VERSION (see
 * s_lib_version.c) during compile time, it cannot be modified
 * in the middle of a program
 */ 
extern  _LIB_VERSION_TYPE  _LIB_VERSION;

#define _IEEE_  fdlibm_ieee
#define _SVID_  fdlibm_svid
#define _XOPEN_ fdlibm_xopen
#define _POSIX_ fdlibm_posix

/*
struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};
*/
#define	HUGE		MAXFLOAT

/* 
 * set X_TLOSS = pi*2**52, which is possibly defined in <values.h>
 * (one may replace the following line by "#include <values.h>")
 */

#define X_TLOSS		1.41484755040568800000e+16 

extern double fabs(double);

extern double erf(double);
extern double erfc(double);

extern double __ieee754_exp(double);

#ifdef __cplusplus
}
#endif
