#ifndef _ON_SPANNING_H_
#define _ON_SPANNING_H_ 1

#include "DMFirstHeader.h"
#include "DiscreteAvalanche.h"
#include "AvalancheListener.h"
#include "CheckSpanning.h"
#include "Serializable.h"

class OnSpanning : public AvalancheListener, public Serializable
{
	CheckSpanning* spanning;
	bool isLatticeSpanned;
	int runIdx;
  int avalancheIdx;
  bool isSavingAllSpans;
public:
	OnSpanning ( void );
	~OnSpanning( void );

	void SetSpanning( CheckSpanning* spanning );

	/*! AvalancheListener interface */
	//@{
	virtual void AvalancheCompleted
		(
		AvalancheAlgorithm*	avalanche, 
		double				dField
		);

	virtual void BeginSweep( bool bKeepData );
	//@}


	/*! Serializable interface */
	//@{
	void Save( DMWriter *writer ) const;
	void Load( DMReader *reader );
	const std::string GetType() const;
	//@}
private:
	void SaveConfiguration( const SpinLattice* const lattice, const std::string& filename );
};

#endif // _ON_SPANNING_H_
