#ifndef _SIMPLE_TRACER_H_
#define _SIMPLE_TRACER_H_

#include "DMFirstHeader.h"
#include "DiscreteAvalanche.h"
#include "Tracer.h"

//! A Tracer for Discrete Avalanches in hysteresis project.
/*! Everything is measured in seconds.
	*/
class SimpleTracer : public Tracer
{
	int uiTraceFrequency; //!< How often to trace.
public:
	//! Constructor.
	SimpleTracer();

	//! Tell us how often to trace
	void SetTraceFrequency( int uiSeconds );

	//! Returns the next time beyond now to trace.
	/*!
		\param uiCurrentTime Time since time=0.
		\param uiEndTime May be zero if there is no end time
		\return Time of next trace beyond current time.
		*/
	int GetNextTrace( int uiCurrentTime,
		int uiEndTime );

	//! Does the tracing.
	void Trace( int uiCurrentTime );
};

#endif //_SIMPLE_TRACER_H_
