#include "DMFirstHeader.h"
#include "WinWallClockTimer.h"
#include "DMLastHeader.h"

WinWallClockTimer::WinWallClockTimer()
{
}

void WinWallClockTimer::Start()
{
	FILETIME ftCurrent;

	::GetSystemTimeAsFileTime( &ftCurrent );
	::memcpy( (void*) &ulStartTime, (const void *) &ftCurrent, sizeof(FILETIME));
	ASSERT( ulStartTime.QuadPart > 0 );
}

unsigned int WinWallClockTimer::GetTime()
{
	FILETIME ftCurrent;
	ULARGE_INTEGER ulInt;

	::GetSystemTimeAsFileTime( &ftCurrent );
	::memcpy( (void*) &ulInt, (const void *) &ftCurrent, sizeof(FILETIME));

	ASSERT( ulInt.QuadPart-ulStartTime.QuadPart >= 0 );
	ASSERT( (((ulInt.QuadPart-ulStartTime.QuadPart)/10000000) >> 32) == 0 );

	return (unsigned int) ((ulInt.QuadPart-ulStartTime.QuadPart)/10000000);
}
