from Hysteresis import *

bt = BatchTimer()
bt.SetEndTimeMinutes( 100 )
tracer = SimpleTracer()
tracer.SetTraceFrequency( 300 )
bt.SetTracer( tracer )

sim = HysteresisSimulation()
sim.SetLength(30)
sim.SetSeed(1)
sim.SetDisorder( 0.9 )
sim.SetBatchTimer( bt )
sim.Initialize()
sim.Verify()
cp = NetCDFCheckpointer()
cp.SetSerializable( sim )
bt.SetCheckpointer( cp )

sim.Run()
sim.SaveResults()
del sim

