#ifndef _HYSTERESIS_FRAME_H_
#define _HYSTERESIS_FRAME_H_

#include "wx/wx.h"
#include "HysteresisSimulation.h"

class HysteresisCanvas;

class HysteresisFrame : public wxFrame
{
	HysteresisSimulation* m_simulation;
	HysteresisCanvas* m_canvas;

	// Timer stuff.
	wxTimer*	m_timer;
	bool		m_running;
	long		m_interval;
	long		m_tics;
public:
	HysteresisFrame();
	virtual ~HysteresisFrame();

private:
	DECLARE_EVENT_TABLE();

	void OnMenu( wxCommandEvent& event );
	void OnClose( wxCloseEvent& event );
	void OnZoom( wxCommandEvent& event);
	void OnTimer( wxTimerEvent& event);

	void OnStart();
	void OnStop();
	void OnStep();
};

#endif // _HYSTERESIS_FRAME_H_
