// RandomInitializer.cpp: implementation of the RandomInitializer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "KMC.h"
#include "RandomInitializer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RandomInitializer::RandomInitializer()
{
	// Drew's registration with MOP: allows Get and Set functions to be called
	// from dialog boxes, in serialization, and for copying
	if (NotYetRegistered("RandomInitializer",typeid(*this))) {
		AddType("RandomInitializer",typeid(*this));
		AddBase("KMCInitializer");
	}
}

RandomInitializer::~RandomInitializer()
{

}

void RandomInitializer::Initialize(KMCLattice *lattice)
{
	for (int atomInCell = 0; atomInCell < lattice->GetBravais()->GetNAtomsPerCell(); atomInCell++)
	{
		for (int index = 0; index < lattice->GetNetSize(); index ++)
		{
			lattice->SetOrderParameter(atomInCell, index, 2*rand.discrete(0,1)-1);
		}
	}
}
