// CompositeClusterInitializer.h: interface for the CompositeClusterInitializer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef COMPOSITECLUSTERINITIALIZER_H
#define COMPOSITECLUSTERINITIALIZER_H

#include "DMFirstHeader.h"
#include "ClusterInitializer.h"

class CompositeClusterInitializer : public ClusterInitializer  
{
public:
	CompositeClusterInitializer(ClusterInitializer *c1, ClusterInitializer *c2, BravaisLatticeWithBasis *lattice,const char *method="intersection");
	virtual ~CompositeClusterInitializer();

protected:
	ClusterInitializer *c1;
	ClusterInitializer *c2;
	int SetMaxSize();
	bool Inside(double X[DIMENSION]);
#ifndef SWIG
	enum {CLUSTER_INTERSECTION,CLUSTER_DIFFERENCE,CLUSTER_UNION} METHOD;
#endif // SWIG
};

#endif // !defined(COMPOSITECLUSTERINITIALIZER_H)
