// VerletAtomsMover.h: interface for the VerletAtomsMover class.
//
//////////////////////////////////////////////////////////////////////

#ifndef VERLETATOMSMOVER_H
#define VERLETATOMSMOVER_H

#include "DigitalMaterial.h"
#include "AtomsMover.h"
#include "Potential.h"

// This is a variant on the Velocity Verlet algorithm. I'm not sure it's 
// standard.

class VerletAtomsMover : public AtomsMover
{
public:
VerletAtomsMover(Potential *potential = 0, double dt = 0.01, int nSteps = 1);
	virtual ~VerletAtomsMover();
	void Move(ListOfAtoms *atoms);

	// Time step for Verlet algorithm
	double GetDt() const {return dt;}
	void SetDt(double dt) {this->dt = dt;}

	double GetTime() const {return time;}
	void SetTime(double time=0.) {this->time = time;}

	// Number of time-steps per call.
	int GetNSteps() const {return nSteps;}
	void SetNSteps(int nSteps) {this->nSteps = nSteps;}
	
#ifndef SWIG
	void Save(DMWriter *writer) const;
	void Load(DMReader *reader);
#endif // SWIG
	const std::string &GetType() const
		{
			return className;
		}

protected:
	void Allocate(const DMArray<double, DIMENSION> *array);
	double time;
	double dt;
	int nSteps;
	DMArray<double, DIMENSION> *forces;
	static const std::string className;
};

#endif // !defined(VERLETATOMSMOVER_H)
