#include "DMFirstHeader.h"

#include "DigitalMaterial.h"

#include "BravaisLatticeWithBasis.h"
#if DIMENSION == 2


class SquareLattice: public BravaisLatticeWithBasis
{
public:
    SquareLattice(double a=1.0);
    ~SquareLattice(){};
    const std::string &GetType() const {return className;}
    void SetLatticeConstant(double a);
    double GetLatticeConstant() const {return latticeConstant;}
protected:
    double latticeConstant;
private:
	static const std::string className;
};

class TriangularLattice: public BravaisLatticeWithBasis
{
public:
    TriangularLattice(double a=1.0);
    ~TriangularLattice(){};
    const std::string &GetType() const {return className;}
    void SetLatticeConstant(double a);
    double GetLatticeConstant() const {return latticeConstant;}
protected:
    double latticeConstant;
private:
	static const std::string className;
};
#endif // DIMENSION == 2
