// ExternalForceConstraint.cpp: implementation of the ExternalForceConstraint class.
//
//////////////////////////////////////////////////////////////////////

#include "DigitalMaterial.h"

#include "ExternalForceConstraint.h"
#include "DMArray.h"

#include "DMLastHeader.h"

const std::string ExternalForceConstraint::className = std::string("ExternalForceConstraint");

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


ExternalForceConstraint::ExternalForceConstraint()
{
	for(int coord=0;coord<DIMENSION;++coord)
		externalForce[coord] = 0.;
}

ExternalForceConstraint::~ExternalForceConstraint()
{

}

Constraint *ExternalForceConstraint::Copy() const
{
	ExternalForceConstraint *newConstraint = new ExternalForceConstraint();
	newConstraint->SetExternalForce(externalForce);
	return newConstraint;
}

void ExternalForceConstraint::AdjustForces(DMArray<double, DIMENSION> *forces)
{
	int coord;
	DMArrayIterator<double, DIMENSION> forcesIter(forces);
	double extForcePerAtom[DIMENSION];
	for(coord=0;coord<DIMENSION;++coord)
		extForcePerAtom[coord] = externalForce[coord]/forces->Size();

	forces->Increment(extForcePerAtom);
}

