// UniformlyMovingBody.cpp: implementation of the UniformlyMovingBody class.
//
//////////////////////////////////////////////////////////////////////

#include "DigitalMaterial.h"

#include "UniformlyMovingBody.h"
#include "DMArray.h"

#include "DMLastHeader.h"

const std::string UniformlyMovingBody::className = std::string("UniformlyMovingBody");

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


UniformlyMovingBody::UniformlyMovingBody(const double velocity[DIMENSION])
{
	for(int coord=0; coord<DIMENSION; coord++) this->velocity[coord] = velocity[coord];
}

Constraint *UniformlyMovingBody::Copy() const
{
  return new UniformlyMovingBody(velocity);
}

void UniformlyMovingBody::SetVelocity(const double velocity[DIMENSION])
{
  for(int coord=0; coord<DIMENSION; coord++) this->velocity[coord] = velocity[coord];
}


void UniformlyMovingBody::AdjustVelocities(DMArray<double, DIMENSION> *velocities)
{
	velocities->Set(velocity);
}

int UniformlyMovingBody::NumberGeneralizedCoordinates()
{
  return 0;
}

void UniformlyMovingBody::SetGeneralizedCoordinates(double *generalizedCoordinates)
{

}

void UniformlyMovingBody::GetGeneralizedCoordinates(double *generalizedCoordinates)
{

} 


void UniformlyMovingBody::IncrementGeneralizedCoordinate(int n,double inc)
{

}

void  UniformlyMovingBody::CalculateGeneralizedForces(DMArray<double, DIMENSION> *forces, double *generalizedForces)
{
  
}


void UniformlyMovingBody::DerivativesWRTGeneralizedCoordinates(int atom, double (*gradient)[DIMENSION])
{

}
