#ifndef _MDTHREAD_H_
#define _MDTHREAD_H_

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

#include "Threadable.h"

class MDSimulation;

//! This is the mainloop of the simulation.
/**
 * This class is responsible for what happens when the simulation runs.
 * Inside the Run() method, we move our atoms, notify observers, and
 * store what we want. 
 * \author Drew Dolgert
 * \date 21 Feb 2000
 * \ingroup moleculardynamics
 */
class MDThread : public Threadable
{
public:
	MDThread(MDSimulation *pSim);
	void Run();
private:
	MDSimulation *pSim;
};

#endif // _MDTHREAD_H_