// LocalForceObserver.h: interface for the LocalForceObserver class.
//
//////////////////////////////////////////////////////////////////////

#ifndef LOCALFORCEOBSERVER_H
#define LOCALFORCEOBSERVER_H

#include "DMFirstHeader.h"
#include <string>
#include <fstream>
#include "DigitalMaterial.h"
#include "ListOfAtomsObserver.h"
#include "DMArray.h"

class Potential;
template<class Type, int N> class DMArray ;

class LocalForceObserver : public ListOfAtomsObserver
{
public:
	LocalForceObserver(Potential *potential, double forceCutoff, std::string fileName, int notifyLevel = 0);
	virtual ~LocalForceObserver();
	void Update(ListOfAtoms *atoms);

private:
	void Allocate(ListOfAtoms *atoms);
	int nAtoms;
	Potential * potential;
	DMArray<double, DIMENSION> *forces;
	std::ofstream *fileObject;
	double forceCutoff;
};

#endif // !defined(LOCALFORCEOBSERVER_H)
