// PythonLOAObserver.h: interface for the PythonLOAObserver class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PYTHONLOAOBSERVER_H
#define PYTHONLOAOBSERVER_H

#include "DMFirstHeader.h"
#include <Python.h>
#include "DigitalMaterial.h"

#include "ListOfAtomsObserver.h"
class PythonLOAObserver : public ListOfAtomsObserver  
{
public:
	PythonLOAObserver(PyObject *updateMethod, PyObject *exitMethod=0, int notifyLevel = 0);
	virtual ~PythonLOAObserver();
	virtual void Update(ListOfAtoms *atoms);

	ListOfAtoms *GetLastLOA() const { return atoms;}
private:
	PyObject *updateMethod;
	PyObject *exitMethod;
	ListOfAtoms *atoms;
};

#endif // PYTHONLOAOBSERVER_H
