// ParallelPotential.h: interface for the ParallelPotential class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PARALLELPOTENTIAL_H
#define PARALLELPOTENTIAL_H

#include "Potential.h"

class ParallelPotential : public Potential  
{
public:
	ParallelPotential(Potential *potential);
	virtual ~ParallelPotential(){}

	double CalculateEnergy(ListOfAtoms *atoms);

	void CalculateForces (ListOfAtoms *atoms, 
                              DMArray<double, DIMENSION> *forces);

	void CalculateForcesBetweenTypes(ListOfAtoms *atoms, 
                                         DMArray<double, DIMENSION> *forces, 
                                         int type1, 
                                         int type2) ;

	double CalculateEnergyAndForces (ListOfAtoms *atoms, 
                                         DMArray<double, DIMENSION> *forces);

	double CalculateAtomicEnergy(ListOfAtoms *atoms, int i);

	double GetEnergyCurvatureScale() const
	{
		return potential->GetEnergyCurvatureScale();
	}

	double GetLengthScale() const
	{
		return potential->GetLengthScale();
	}

	double GetCutoffDistance2() const
	{
		return potential->GetCutoffDistance();
	}

	double GetCutoffDistance() const
	{
		return potential->GetCutoffDistance();
	}


private:
	Potential *potential;
};

#endif // !defined PARALLELPOTENTIAL_H
