// GravityPotential.h: interface for the GravityPotential class.
//
//////////////////////////////////////////////////////////////////////

#ifndef GRANULARPOTENTIAL_H
#define GRANULARPOTENTIAL_H

#include "DMFirstHeader.h"

#include "DigitalMaterial.h"
#include "Potential.h"

class GranularPotential : public Potential
{
public:
	GranularPotential();
	GranularPotential(double pD, double eC, double dP);
	virtual ~GranularPotential() {};

	void CalculateForces(ListOfAtoms *atoms, DMArray<double, DIMENSION> *forces);
	double CalculateEnergy(ListOfAtoms *atoms);	

	double GetLengthScale() const {return particleDiameter;} 
	double GetEnergyCurvatureScale() const {return 1.;} 
	double CalculateAtomicEnergy(ListOfAtoms *atoms, int i) {return 0;} ;
//	double GetInnerCutoffDistance() const {return 0;}
	
	void Save(DMWriter *writer) const
		{
		}
	void Load(DMReader *reader)
		{
		}

	//! Get the string name of the class for saving or loading.
	const std::string &GetType() const
	{
		return className;
	}

#ifndef SWIG
private:
	double particleDiameter;
	double elasticConstant;
	double dampingParameter;

	static const std::string className;
#endif // SWIG 
};

#endif // !defined(GRANULARPOTENTIAL_H
