// CopySubset.h: interface for the CopySubset class.
//
//////////////////////////////////////////////////////////////////////

#ifndef COPYSUBSET_H
#define COPYSUBSET_H

#include "DMFirstHeader.h"
#include "DigitalMaterial.h"
#include "ElasticFieldTransformer.h"
class AtomsLocator;


//! This will create a new ListOfAtoms which is a copy of a subset of the given ListOf Atoms


/*!

  You pass to the constructor a pointer to an AtomsLocator, which has a
  function GetAtomNumbers which provides a vector of the atom numbers to which
  the transformation is to be applied.

  \author nbailey
  \date 3/25/2002
  \ingroup moleculardynamics

 */


class CopySubset
{
public:
	CopySubset(AtomsLocator *locator);
	virtual ~CopySubset();

	ListOfAtoms * Copy(ListOfAtoms *atoms);
	
private:
#ifndef SWIG
	AtomsLocator *locator;
#endif // SWIG
};

#endif // !defined(COPYSUBSET_H)
