// ElasticFieldTransformer.h: interface for the ElasticFieldTransformer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef ELASTICFIELDTRANSFORMER_H
#define ELASTICFIELDTRANSFORMER_H


#include "DMFirstHeader.h"
#include <math.h>
#include "DigitalMaterial.h"
#include <assert.h>

#include "Transformer.h"
#include "ListOfAtoms.h"


class ElasticFieldTransformer : public Transformer
{
public:
	//! ElasticDisplacement zeros---previous value is erased
	virtual void ElasticDisplacement(const double position[DIMENSION], double displacement[DIMENSION])=0;

	//! GradientWRTPosition adds to (and doesn't zero) the array  
	virtual void GradientWRTPosition(const double position[DIMENSION],  double gradientWRTPosition[DIMENSION][DIMENSION])=0;


	void Transform(ListOfAtoms *atoms);

private:

};

#endif // !defined(ELASTICFIELDTRANSFORMER_H)
