// SliceAtomsLocator.cpp: implementation of the SliceAtomsLocator class.
//
//////////////////////////////////////////////////////////////////////

#include "DigitalMaterial.h"
#include "SliceAtomsLocator.h"
#include "ListOfAtoms.h"
#include "NeighborLocator.h"

#include "DMLastHeader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SliceAtomsLocator::SliceAtomsLocator(double center[DIMENSION], double normal[DIMENSION], double thickness)
{
	SetCenter(center);
	SetNormal(normal);
	SetThickness(thickness);
}

SliceAtomsLocator::~SliceAtomsLocator()
{

}


bool SliceAtomsLocator::Inside(const double *position)
{
	// need to figure out how to deal with periodic boundary conditions!
	// (maybe apply DifferenceBC to disp)
	double disp[DIMENSION];
	double dotProd = 0.;
	for( int coord = 0; coord < DIMENSION; ++coord )
	{
		disp[coord] = position[coord] - center[coord];
		dotProd += disp[coord] * normal[coord];
	}

	return fabs(dotProd) < 0.5 * thickness;
}
