// SphereAtomsLocator.h: interface for the SphereAtomsLocator class.
//
//////////////////////////////////////////////////////////////////////

#ifndef SPHEREATOMSLOCATOR_H
#define SPHEREATOMSLOCATOR_H

#include "DMFirstHeader.h"
#include "DigitalMaterial.h"
#include "AtomsLocator.h"


//!


/*!

  \author nbailey
  \date 7/11/2001
  \ingroup moleculardynamics

 */


class SphereAtomsLocator : public AtomsLocator
{
public:
	SphereAtomsLocator(double center[DIMENSION], double radius);
	virtual ~SphereAtomsLocator();
	bool Inside(const double *position);

#ifndef SWIG
	const std::vector<int> &GetAtomNumbers(ListOfAtoms *atoms);
	
private:
	void AllocateForNeighborLocator(int nSpaces);
	double center[DIMENSION];
	double radius;

	int nSpaces;
	double *displacementsSq;
	double (*displacements)[DIMENSION];
	int *neighbors;
#endif // SWIG
};

#endif // !defined(SPHEREATOMSLOCATOR_H)
