// Translator.cpp: implementation of the Translator class.
//
//////////////////////////////////////////////////////////////////////
#include "DigitalMaterial.h"
#include "Translator.h"
#include "ListOfAtoms.h"

#include "DMLastHeader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Translator::Translator(double shift[DIMENSION])
{
	SetShift(shift);	
}

Translator::~Translator()
{

}

void Translator::SetShift(const double shift[DIMENSION])
{
  double shiftMag = 0.;
  for(int coord=0;coord<DIMENSION;++coord)
    { 
      this->shift[coord] = shift[coord];
      shiftMag += shift[coord]*shift[coord];
    }
  shiftMag = sqrt(shiftMag);
}

void Translator::Transform(ListOfAtoms *atoms)
{
	DMArray<double, DIMENSION> temp(atoms->GetShape());
	temp.Copy(atoms->GetCartesianPositions());
	temp.Increment(shift);
	atoms->SetCartesianPositions(&temp);
}


