// VoidMaker.cpp: implementation of the VoidMaker class.
//
//////////////////////////////////////////////////////////////////////

#include "DMFirstHeader.h"
#include <set>

#include "DigitalMaterial.h"

#include "VoidMaker.h"
#include "DMArray.h"
#include "ListOfAtoms.h"

#include "DMLastHeader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

VoidMaker::VoidMaker()
{
}

VoidMaker::~VoidMaker()
{

}

void VoidMaker::Transform(ListOfAtoms *atoms)
{
	int atom=0, currentAtom;
	std::set<int> atomsToRemove;
	DMArrayIterator<double, DIMENSION> currentPosition(atoms->GetCartesianPositions());

	currentPosition.Init();
	for(currentAtom=0; currentAtom<atoms->GetNumber(); currentAtom++)
	{
		if(!Inside(currentPosition.Current())) atomsToRemove.insert(currentAtom);
		currentPosition.Next();
	}
	atoms->RemoveAtoms(atomsToRemove);
}

