#if DIMENSION == 3
%module MD3D
#else
%module MD2D
#endif

%include DMSystem.i

%{
#include <vector>
#include <string>
%}

%include stringTypeMap.i


/// Convert type[DIMENSION] to python lists or numpy arrays
%include "DimensionArrayTypeMap.i"


/// base classes:


%include cpointer.i

/// BRAVAIS LATTICES ///
%include BravaisLatticeWithBasis.i

/// SHAPE ///
%include Shape.i

/// MATRIX AND VECTORS ///
%include DMArray.i


/// ATOMS INITIALIZERS ///
%include "AtomsInitializers.i"

/// LISTS OF ATOMS ///
%include "ListOfAtoms.i"

/// POTENTIALS ///
%include "Potentials.i"

/// NEIGHBOR LOCATORS ///
%include "NeighborLocators.i"

/// ATOMS MOVERS ///
%include "AtomsMovers.i"

/// BOUNDARY CONDITIONS ///
%include "BoundaryConditions.i"

/// TRANSFOMERS ///
%include "Transformers.i"

/// LOAOBSERVERS ///
%include "Observers.i"

/// CONSTRAINTS ///
%include "../MDFiles/Constraints/Constraints.i"  # there's already a file "constraints.i" in SWIG's includes.

/// UNIXINTERFACE ///
#ifndef _WINDOWS
%include "UnixInterface.i"
#endif // WINDOWS

/// PARALLEL ///
#ifdef DMPARALLEL
%include "ParallelMD.i"
#endif

