/* DialogIDManager.h
 * Drew Dolgert 19 Feb 2000
 * This class is responsible for giving clients a unique
 * integer ID out of a range of integer IDs.  It also reclaims
 * old IDs if the client is kind enough to release them.
 *
 * The implementation is in IDResourceManager.h.
 */
#ifndef _DIALOGIDMANAGERMANAGER_H_
#define _DIALOGIDMANAGERMANAGER_H_

#include "IDResourceManager.h"

/*! \ingroup windows */
class DialogIDManager
{
private:
	static DialogIDManager* _instance;
	IDResourceManager resourceManager;
public:
	static DialogIDManager *Instance() {
		if (_instance==0) _instance = new DialogIDManager();
		return _instance;
	}
	int GetID() { return resourceManager.GetID(); }
	void ReleaseID(int ID) { resourceManager.ReleaseID(ID); }
	virtual ~DialogIDManager() {}
protected:
	DialogIDManager() : resourceManager(0xa000,0xFFFF) { }
};

#endif // _DIALOGIDMANAGERMANAGER_H_
