#include "vtkPropSource.h"
#include "SphereListener.h"

vtkPropSource::vtkPropSource()
{
	this->Props = vtkPropCollection::New();
}

vtkPropSource::~vtkPropSource()
{
	if (this->Props) this->Props->Delete();
}

void vtkPropSource::AddListener(SphereListener *listener)
{
	listeners.push_back(listener);
}

void vtkPropSource::RemoveListener(SphereListener *listener)
{
	listeners.remove(listener);
}

void vtkPropSource::Notify()
{
	std::list<SphereListener*>::iterator start = listeners.begin();
	std::list<SphereListener*>::iterator end = listeners.end();
	while (start != end) {
		(*start)->SphereUpdate();
		start++;
	}
}