/*
 * vtkPropSource -- Drew Dolgert 14 Feb 2000
 * This class is responsible for providing a property collection
 * to a viewer.  The property collection is initialized by subclassing.
 */
#ifndef _VTKPROPSOURCE_H_
#define _VTKPROPSOURCE_H_

#include "vtkActorCollection.h"
#include "vtkVolumeCollection.h"
#include "vtkActor2DCollection.h"
#include <list>
class SphereListener;

/*! \ingroup windows */
class vtkPropSource
{
public:
	vtkPropSource();
	virtual ~vtkPropSource();
	virtual vtkPropCollection *GetProps() {return this->Props;};
	void AddListener(SphereListener *listener);
	void RemoveListener(SphereListener *listener);
protected:
	void Notify();
private:
	vtkPropCollection *Props;
	std::list<SphereListener*> listeners;
};
#endif //_VTKPROPSOURCE_H_