/*
 * vtkSphereFilter - Drew Dolgert 14 Feb 2000
 * This class is an observer of ListOfAtoms.  It is responsible
 * for translating a pointer to atom coordinates into 
 * a vtk representation.
 */
#ifndef _VTKSPHEREFILTER_H_
#define _VTKSPHEREFILTER_H_

#include "vtkPolyDataMapper.h"
#include "vtkPolyData.h"
#include "vtkFloatPoints.h"
#include "vtkSphereSource.h"
#include "vtkGlyph3D.h"

#include "SubjectObserver.h"
#include "vtkPropSource.h"
class MDSimulation;
class ListOfAtoms;
class SphereListener;
#include <vector>

/*! \ingroup windows */
class vtkSphereFilter : public Observer, public vtkPropSource
{
public:
	vtkSphereFilter(MDSimulation *sim);
	void Update(Subject *theSubject);
	virtual ~vtkSphereFilter();
	// Override from vtkPropSource
	virtual vtkPropCollection *GetProps();
private:
	void ChainIntegrity();
	void GetCurrentPolyData();
	ListOfAtoms* pAtoms;
	bool bDirty;
	vtkPolyDataMapper *Mapper;
	vtkActor *Actor;
	vtkPolyData *pAtomPolyData;
	vtkFloatPoints *pAtomCoords;
	vtkSphereSource *ball;
	vtkGlyph3D *balls;
};

#endif //_VTKSPHEREFILTER_H_