import Numeric
import UserDict, UserList
from Vectors import *

class Point(Vector):

    def __init__(self, ID=None, coords=None):
        self.ID = ID
        Vector.__init__(self, coords)

    def __repr__(self):
        s = 'Point(%d): %s' % (self.ID, self.array)
        return s


class PointSet(UserList.UserList):

    def __init__(self, data=[]):
        self.data = data

    def __repr__(self):
        s = `self.dimension()` + '\n'
        s = s + `self.NumberOfPoints()` + '\n'
        for p in self.data:
            s = s + '%21.17f %21.17f %21.17f\n' % (p[0], p[1], p[2])
        return s

    def NumberOfPoints(self):
        return len(self.data)

    def dimension(self):
        points = self.data
        if len(points) != 0:
            return len(points[0])
        else:
            return 0

    def shape(self):
        return (self.NumberOfPoints(), self.dimension())

    def points(self):
        return self.data

    def toFile(self, filename):
        f = open(filename, 'w')
        f.write(`self.dimension()` + '\n')
        np = self.NumberOfPoints()
        f.write(`np` + '\n')
        dim = self.dimension()
        for p in self.data:
            for d in range(dim):
                f.write('%21.17f ' % p[d])
            f.write('\n')
        f.close()

    def xxtend(self, pointSet):
        current_maxkey = max(self.data.keys())
        try:
            start_key = current_maxkey + 1
        except:
            raise TypeError, "addition not defined on current_maxkey"
        
        for p in pointSet.items():
            index = start_key + p[0]
            if not self.data.has_key(index):
                self.data[index] = p[1]

        
