import VTK, sys

class Avatar:

    def __init__(self, polydata, lookupTable):
        self.polydata = polydata
        self.lookupTable = lookupTable

        self.ren = VTK.vtkRenderer()
        self.renWin = VTK.vtkRenderWindow()
        self.renWin.AddRenderer(self.ren)
        self.renWin.SetSize(500,500)

        self.iren = VTK.vtkRenderWindowInteractor()
        self.iren.SetRenderWindow(self.renWin)

        self.polydata.Update()

        self.mapper = VTK.vtkDataSetMapper()
        self.mapper.SetInput(self.polydata)
        if self.lookupTable is not None:
            self.mapper.SetLookupTable(self.lookupTable)
        self.actor  = VTK.vtkActor()
        self.actor.SetMapper(self.mapper)
        self.ren.SetBackground(0.,0.,0.)
        self.ren.AddActor(self.actor)

        self.ren.GetActiveCamera().Azimuth(30)
        self.ren.GetActiveCamera().Elevation(20)
        self.ren.GetActiveCamera().Dolly(1.0)
        self.ren.ResetCameraClippingRange()
        self.renWin.Render()

        self.display()

    def display(self):
        self.iren.Initialize()
        self.iren.Start()

    def restart(self):
        self.iren.Start()

