#
#

from distutils.core import setup, Extension

setup (name = "PX",
       version = "0.2",
       description = "Python/Polycrystal Package",
       author = "Chris Myers",
       author_email = "myers@tc.cornell.edu",
       url = "http://www.tc.cornell.edu/~myers",
       long_description = """PX is a package for 
           studying polycrystalline geometries and texture within 
           the Digital Material framework""",
       package_dir = {'DigitalMaterial':'Python/DigitalMaterial'},
       packages = ["DigitalMaterial",
                   "DigitalMaterial.PX", 
                   "DigitalMaterial.PX.Attributes",
                   "DigitalMaterial.PX.Geometry",
                   "DigitalMaterial.PX.Geometry.Common",
                   "DigitalMaterial.PX.Geometry.Models",
                   "DigitalMaterial.PX.Geometry.Tesselation",
                   "DigitalMaterial.PX.Geometry.Tesselation",
                   "DigitalMaterial.PX.Structures",
                   "DigitalMaterial.PX.Structures.Polycrystals",
                   "DigitalMaterial.PX.Tools",
                   "DigitalMaterial.PX.Tools.Polycrystals",
                   "DigitalMaterial.PX.Tools.Utils",
                   "DigitalMaterial.PX.Tools.Viz"],
       ext_modules = [Extension("DigitalMaterial.PX.Geometry.Common.geoPoly3D", \
           ["Python/DigitalMaterial/PX/Geometry/Common/geoPoly3D.c",
            "Python/DigitalMaterial/PX/Geometry/Common/geoPoly3D_wrap.i"])]                              
      )
