#ifndef ANALYTICSPLITEULER_H
#define ANALYTICSPLITEULER_H

#ifdef _DEBUG
#include <assert.h>
#endif

#include <typeinfo>
#include "DigitalMaterial.h"
#include "Field.h"
#include "SplitRightHandSide.h"
#include "OperatorSplitFieldMover.h"
#include "OperatorOperand.h"
#include "BinaryOperators.h"
#include "UnaryOperators.h"
#include "FieldCollection.h"


//#include "Introspective.h"
//#include "Clonable.h"


class AnalyticControlEuler : public OperatorSplitFieldMover //, public Introspective, public Cloneable
{
	protected:
		Real step_size;

		// Array to pointers to work space fields.
		// The workspace here contains the time derivatives.
		FieldCollection WorkSpace;
		FieldCollection ErrorEstimate;

		MakeEqual Equal;
		AddField Add;
		MultiplyReal Times;
		SubtractField Subtract;

		virtual void FreeWorkSpace();
		virtual void FreeErrorEstimate();

	public:
		AnalyticControlEuler(void);
#ifndef SWIG
		AnalyticControlEuler(Real step, SplitRightHandSide *RHS);
		AnalyticControlEuler(const AnalyticControlEuler & exeuler);
#endif //SWIG
		virtual ~AnalyticControlEuler();

		virtual bool SetStepSize(Real step) { step_size=step; return(true); }
		virtual Real GetStepSize(void) const { return(step_size); }
		virtual bool SetWorkSpace(const FieldCollection & field);
		virtual FieldCollection & GetWorkSpace(void) { return(WorkSpace); }
		virtual FieldCollection & GetErrorEstimate(void) { return(ErrorEstimate); }
#ifndef SWIG
		virtual const FieldCollection & GetWorkSpace(void) const { return(WorkSpace); }
		virtual const FieldCollection & GetErrorEstimate(void) const { return(ErrorEstimate); }
#endif //SWIG

		//virtual bool SafeMove(FieldCollection & fields);
		virtual bool Move(FieldCollection & fields);

};


#endif
