#ifndef ANALYTICSPLITEULER_H
#define ANALYTICSPLITEULER_H

#ifdef _DEBUG
#include <assert.h>
#endif

#include <typeinfo>
#include "DigitalMaterial.h"
#include "Field.h"
#include "SplitRightHandSide.h"
#include "OperatorSplitFieldMover.h"
#include "OperatorOperand.h"
#include "BinaryOperators.h"
#include "UnaryOperators.h"
#include "FieldCollection.h"


//#include "Introspective.h"
//#include "Clonable.h"


class AnalyticSplitEuler : public OperatorSplitFieldMover //, public Introspective, public Cloneable
{
	protected:
		Real step_size;

		// Array to pointers to work space fields.
		// The workspace here contains the time derivatives.
		FieldCollection WorkSpace;

		MakeEqual Equal;
		AddField Add;
		MultiplyReal Times;

		virtual void FreeWorkSpace();

	public:
		AnalyticSplitEuler(void);
#ifndef SWIG
		AnalyticSplitEuler(Real step, SplitRightHandSide *RHS);
		AnalyticSplitEuler(const AnalyticSplitEuler & exeuler);
#endif //SWIG
		virtual ~AnalyticSplitEuler();

		virtual bool SetStepSize(Real step) { step_size=step; return(true); }
		virtual Real GetStepSize(void) const { return(step_size); }
		virtual bool SetWorkSpace(const FieldCollection & field);
		virtual FieldCollection & GetWorkSpace(void) { return(WorkSpace); }
#ifndef SWIG
		virtual const FieldCollection & GetWorkSpace(void) const { return(WorkSpace); }
#endif //SWIG

		virtual bool SafeMove(FieldCollection & fields);
		virtual bool Move(FieldCollection & fields);

};


#endif
