#ifndef DIFFUSIONEQUATION_H
#define DIFFUSIONEQUATION_H

#ifdef _DEBUG
#include <assert.h>
#endif

#include "DigitalMaterial.h"
#include "Field.h"
#include "RightHandSide.h"
#include "OperatorOperand.h"
#include "UnaryOperators.h"
#include "BinaryOperators.h"
#include "FieldCollection.h"

//#include "Introspective.h"
//#include "Clonable.h"


class DiffusionEquation : public RightHandSide //, public Introspective, public Cloneable
{
	protected:
		Real diffusivity;
		Laplacian Laplace;
		MakeEqual Equal;
		MultiplyReal Times;
	public:
		DiffusionEquation(void);
		DiffusionEquation(const DiffusionEquation &deq);
		virtual ~DiffusionEquation(void);
		//virtual bool RHS(Field ** phi);
		virtual bool RHS(const FieldCollection & input, FieldCollection & output);
		virtual Real GetDiffusivity(void) const { return(diffusivity); }
		virtual bool SetDiffusivity(Real dd) { diffusivity=dd; return(true); }
};


#endif
