/* Defines the dimension of space: change it once, everything recompiles */
#ifndef DIGITALMATERIAL_H  
#define DIGITALMATERIAL_H  

#ifndef DIMENSION
#define DIMENSION 3
#endif

#ifndef SWIG
// Definition of Pi
#ifndef _WIN32 
	#define PI M_PI  
#else
	#define PI 3.1415926535897932
	#pragma warning(disable:4786) // turns off spurious Windows STL warnings
#endif // _WIN32
#endif //SWIG

#define ZERO 0

// To save RAM space and to check for rounding errors:
// switch between float and double - supported by FFTW
#ifdef USE_FLOAT
	#define FFTW_ENABLE_FLOAT
	typedef float Real;
#else
	typedef double Real;
	#undef FFTW_ENABLE_FLOAT
#endif //USE_FLOAT

#endif //DIGITALMATERIAL_H
