#ifndef FIELDCOLLECTION_H
#define FIELDCOLLECTION_H

#include <deque>
#include "DigitalMaterial.h"
#include "Field.h"

class FieldCollection
{
	private:
		#ifndef SWIG
			std::deque<Field*> fields;
		#endif //SWIG
	public:
		FieldCollection();
		virtual ~FieldCollection();
		
		virtual int GetNumberOfFields() const { return(fields.size()); }
		virtual bool AddField(Field * f);
#ifndef SWIG
		virtual bool AddField(Field &f) { return(AddField(&f)); }
#endif //SWIG
		virtual bool RemoveAllFields();
		
#ifndef SWIG
		Field & operator[](const int i) { return(*(fields[i])); }
		const Field & operator[](const int i) const { return(*(fields[i])); }
#endif //SWIG
		Field & GetField(int i);
};

#endif //FIELDCOLLECTION_H
