#ifndef FIELDINITIALIZER_H
#define FIELDINITIALIZER_H

#ifdef _DEBUG
#include <assert.h>
#endif

#include "DigitalMaterial.h"
#include "Point.h"

//#include "Introspective.h"
//#include "Clonable.h"

class FieldInitializer // : public virtual Introspective, public Cloneable // not yet!
{
protected:
	Point * dangerous_point;
	Real  * danger_of_point;
	int total_no_of_dangerous_points;
	virtual const Point * GetDangerousPointsPoints() const { return(dangerous_point); }
	virtual const Real * GetDangers() const { return(danger_of_point); }
	virtual bool SetDangerousPoints(int num, const Point * p, const Real * d);
public:
#ifndef SWIG
	FieldInitializer();
	FieldInitializer(const FieldInitializer & initializer);
	virtual ~FieldInitializer();
	virtual bool SetTotalNumberOfDangerousPoints(const int number);

	virtual bool SetDangerousPoint(const int i, const Point & point, Real danger=0.0);
	virtual bool SetDangerOfPoint(const int i, Real danger);
	virtual Point GetDangerousPoint(const int i) const;
	virtual Real GetDanger(const int i) const; 
	virtual Real GetMaximumDanger() const;
		
	virtual Real FieldValue(const Point & x) const =0;

	virtual Real Danger(const Point & x, const Real resolution) const { return(0.0); }
	virtual Point DangerousPointPoint(const int i, const Real resolution) const { exit(-1); }
	virtual int NumberOfDangerousPoints(const Real resolution) const { return(0); }
	virtual int GetTotalNumberOfDangerousPoints() const { return(total_no_of_dangerous_points); }
#endif //SWIG
};

#endif
