#include "AdvectionEquation.h"

AdvectionEquation::AdvectionEquation(void) : RightHandSide(), velocity(0.0)
{
	// introspective
}

AdvectionEquation::AdvectionEquation(const AdvectionEquation &adveq) : RightHandSide(adveq), velocity(adveq.GetVelocity())
{
}

AdvectionEquation::~AdvectionEquation(void)
{	
	velocity.Zero();
}

bool AdvectionEquation::RHS(const FieldCollection &input, FieldCollection &output)
{
	//	Point vv(velocity);
	const Field &Phi=input[0]; 
	Field &dPhidt=output[0];

	Equal[dPhidt][Phi];
	grad_x_(velocity)[dPhidt]; 	//phi[0][0].DirectionalDerivative(vv);
	Times(-1.0)[dPhidt];		//phi[0][0]*=-1.0;

	return(true);
}
