#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ReadInput.h"

int ReadInput(FILE *input, const char *search, int *value)
{
	double dvalue;
	ReadInput(input, search, &dvalue);
	*value=(int)dvalue;
	return(*value);
}

double ReadInput(FILE *input, const char *search, double *value)
{
	char line[LINE_LENGTH_IN_READINPUT_H], vname[LINE_LENGTH_IN_READINPUT_H], vstring[LINE_LENGTH_IN_READINPUT_H], dreck[LINE_LENGTH_IN_READINPUT_H];
	int ende, lnum=0, found=0;

	rewind(input);
	do  {
		fgets(line, LINE_LENGTH_IN_READINPUT_H, input);
		ende=feof(input);
		if (!ende && '#'!=line[0] && '\n'!=line[0]) {
			lnum++;
			/* printf("#%s#", line); */
			if (2!=sscanf(line, "%s %s %s", vname, vstring, dreck))
				printf("Error in input line %d!\n", lnum);
			else {
				/* printf("vname=\"%s\" vstring=\"%s\"\n", vname, vstring); */
				if (
#ifndef _WIN32
					!strcasecmp(search, vname)
#else		
					!strcmp(search, vname)
#endif
					) {
					if (1!=sscanf(vstring, "%lg %s", value, dreck))
						printf("Error in value \"%s\" in input line %d!\n", 
							vname, lnum);
					else {
						/* printf("%s=%lg\n", vname, *value); */
						found++;
					}
				}
			}
		}
	} 
	while (!ende) ;

	if (found>1) printf("WARNING: multiple definition of \"%s\" = %g\n", search, *value);
	/*
	if (found) printf("\n Final value (%d): %lg\n", found, *value);
	else printf("\n Value not found!\n");
	*/

	return(*value);
}
/* -------------------------------- */

char * ReadInput(FILE *input, const char *search, char *value)
{
	char line[LINE_LENGTH_IN_READINPUT_H], vname[LINE_LENGTH_IN_READINPUT_H], vstring[LINE_LENGTH_IN_READINPUT_H], dreck[LINE_LENGTH_IN_READINPUT_H];
	int ende, lnum=0, found=0;

	rewind(input);
	do  {
		fgets(line, LINE_LENGTH_IN_READINPUT_H, input);
		ende=feof(input);
		if (!ende && '#'!=line[0] && '\n'!=line[0]) {
			lnum++;
			/* printf("#%s#", line); */
			if (2!=sscanf(line, "%s %s %s", vname, vstring, dreck))
				printf("Error in input line %d!\n", lnum);
			else {
				/* printf("vname=\"%s\" vstring=\"%s\"\n", vname, vstring); */
				if (
#ifndef _WIN32
					!strcasecmp(search, vname)
#else		
					!strcmp(search, vname)
#endif				
					) {
					if (1!=sscanf(vstring, "%s %s", value, dreck))
						printf("Error in value \"%s\" in input line %d!\n", 
							vname, lnum);
					else {
						/* printf("%s=\"%s\"\n", vname, value); */
						found++;
					}
				}
			}
		}
	} 
	while (!ende && !found) ;
	if (found>1) printf("WARNING: multiple definition of \"%s\" = %s\n", search, value);
	/*
	if (found) printf("\n Final value (%d): %s\n", found, value);
	else printf("\n Value not found!\n");
	*/

	return(value);
}
/* -------------------------------- */

void ReadNumber(double & number)
{
	char buf[LINE_LENGTH_IN_READINPUT_H];
	double x;
	fgets(buf, LINE_LENGTH_IN_READINPUT_H, stdin);
	if (buf[0]!=0) if (1==sscanf(buf, "%lf", &x)) number=x;
}
void ReadNumber(int & number)
{
	char buf[LINE_LENGTH_IN_READINPUT_H];
	int x;
	fgets(buf, LINE_LENGTH_IN_READINPUT_H, stdin);
	if (buf[0]!=0) if (1==sscanf(buf, "%d", &x)) number=x;
}
