#include "SimpleDirichletBC.h"
#include <new>

using namespace std;

SimpleDirichletBC::SimpleDirichletBC() : physical_size(0.0), helicity(0.0)
{
	//Introspective
}

SimpleDirichletBC::SimpleDirichletBC(const SimpleDirichletBC & spbc) : physical_size(spbc.GetPhysicalSize()), helicity(spbc.GetHelicity())
{
	//Introspective has been done by spbc!
}

BoundaryCondition * SimpleDirichletBC::AllocCopy(void) const
{
	SimpleDirichletBC *sdbc = new(nothrow) SimpleDirichletBC(*this);
	#ifdef _DEBUG
		assert(sdbc);
	#endif
	return(sdbc);
}

SimpleDirichletBC::SimpleDirichletBC(const Point & box) : physical_size(box), helicity(0.0)
{
	//Introspective
	if (!physical_size.IsPositive()) physical_size.Zero();
	// Throw exeption???
}

bool SimpleDirichletBC::SetPhysicalSize(const Point &x)
{
	if (x.IsPositive()) {
		physical_size=x;
		return(true);
	}
	else return(false);
}
