// DMMain.cpp : main loop to check Shape Function of Tet
#include "DMFirstHeader.h"
#include <iostream>
#include <vector>
#include "DigitalMaterial.h"
#include "ElementTopology.h"
#include "ElementShape.h"
#include "ElementLinearTetrahedron.h"
#include "DMLastHeader.h"

using namespace std;

void main(int argv, char **argc)
{
    DMMATRIX<int,DIMENSION> nodes(4) ;
    vector<int> conn(4) ;
	ElementTopology* topoServer = new ElementTopologyTetrahedronT4;
	ElementShape* shapeServer = new ElementShapeTetrahedronT4;
	nodes[0][0] = 0 ; nodes[0][1] = 0 ; nodes[0][2] = 0 ; 
	nodes[1][0] = 5 ; nodes[1][1] = 0 ; nodes[1][2] = 0 ; 
	nodes[2][0] = 0 ; nodes[2][1] = 5 ; nodes[2][2] = 0 ; 
	nodes[3][0] = 0 ; nodes[3][1] = 0 ; nodes[3][2] = 5 ;
	conn[0] = 0 ; conn[1] = 1; conn[2] =2; conn[3] =3 ;
	Element* elem = new ElementLinearTetrahedron(shapeServer, topoServer, &conn, nodes, 0) ;
	int query[3]={0,1,3};
	const double* shape ;
	shape = elem->ComputeShapeFunctionsAtQueryLatticeIndices(query) ;
	cout << shape[0] << " " << shape[1] << " " << shape[2] << " " << shape[3] << endl ;
}
